package admin

import (
	"github.com/gin-gonic/gin"
	"gogs.daxia.dev/huanan/pkg.daxia.dev/db"
	"gogs.daxia.dev/huanan/pkg.daxia.dev/webutils"
	"nn.daxia.dev/model"
)

func ChangeAmount(c *gin.Context) {
	userID := c.Query("user_id")
	typeIndex := c.Query("type")
	amount := c.Query("amount")

	var err error

	if typeIndex == "1" {
		err = db.GetDB().Model(model.User{}).Where("id = ?", userID).Update("credits", amount).Error
	} else {
		err = db.GetDB().Model(model.User{}).Where("id = ?", userID).Update("balance", amount).Error
	}

	if err != nil {
		webutils.FailedResponseErr(c, err)
		return
	}

	webutils.SuccessResponse(c, "ok")
}
